import es, os

status = 0

class AdminError(Exception):
    pass
class FileError(Exception):
    pass

	
def get_clients():
	global admin, status
	if status == 1:
		admin.clear()
	if status == 0:
		admin = {}
		status = 1
	clientsPath = str(es.ServerVar('eventscripts_gamedir'))+'/cfg/mani_admin_plugin/clients.txt'
	if not os.path.isfile(clientsPath):
		raise FileError("Couldn't load clients.txt: No such file")
	file = open(clientsPath, 'r')
	filefixed = os.tmpfile()
	for line in file:
		if not line.startswith('\n'):
			n=0
			while line[n] in [' ', '	']:
				n+=1
			while n < len(line):
				filefixed.write(line[n])
				n+=1
	file.close()
	a=0
	type = 0
	b=0
	steam = ""
	name = ""
	immune_flags = []
	admin_flags = []
	admin_groups = []
	immune_groups = []
	group_name = ""
	group_flags = []
	flag = ""
	filefixed.seek(0)
	for line in filefixed.read().splitlines():
		if line.startswith('"players"'):
			type = 1
		elif type == 1:
			if line.startswith('{'):
				a+=1
			elif line.startswith('}'):
				if a==2:
					if str(steam) != "":
						admin[steam] = {'name':name, 'admin_flags':[] , 'immune_flags':[], 'admin_groups':[], 'immune_groups':[]}
					while len(admin_flags)>0:
						if str(steam) != "":
							admin[steam]['admin_flags'].append(admin_flags[0])
						admin_flags.remove(admin_flags[0])
					while len(immune_flags)>0:
						if str(steam) != "":
							admin[steam]['immune_flags'].append(immune_flags[0])
						immune_flags.remove(immune_flags[0])
					while len(admin_groups)>0:
						if str(steam) != "":
							admin[steam]['admin_groups'].append(admin_groups[0])
						admin_groups.remove(admin_groups[0])
					while len(immune_groups)>0:
						if str(steam) != "":
							admin[steam]['immune_groups'].append(immune_groups[0])
						immune_groups.remove(immune_groups[0])
					steam = ""
					name = ""
				a-=1
				if a==0:
					type = 2
					b=0
			elif a==2:
				if line.startswith('"name"'):
					n=6
					while line[n] != '"':
						n+=1
					n+=1
					while line[n] != '"':
						name += str(line[n])
						n+=1
				elif line.startswith('"steam"'):
					n=7
					while line[n] != '"':
						n+=1
					n+=1
					while line[n] != '"':
						steam += str(line[n])
						n+=1
				elif line.startswith('"flags"'):
					b=1
				elif line.startswith('"groups"'):
					b=2
			elif a==3:
				if b==1:
					if line.startswith('"Immunity"'):
						n=10
						while line[n] != '"':
							n+=1
						n+=1
						while line[n] != '"':
							if line[n] not in [' ', '	']:
								immune_flags.append(line[n])
							n+=1
					elif line.startswith('"Admin"'):
						n=7
						while line[n] != '"':
							n+=1
						n+=1
						while line[n] != '"':
							if line[n] not in [' ', '	']:
								admin_flags.append(line[n])
							n+=1
				elif b==2:
					if line.startswith('"Immunity"'):
						n=10
						while line[n] != '"':
							n+=1
						n+=1
						while line[n] != '"':
							flag+=line[n]
							n+=1
						immune_groups.append(flag)
						flag = ""
					elif line.startswith('"Admin"'):
						n=7
						while line[n] != '"':
							n+=1
						n+=1
						while line[n] != '"':
							flag+=line[n]
							n+=1
						admin_groups.append(flag)
						flag = ""

		elif type == 2:
			if line.startswith('{'):
				a+=1
			elif line.startswith('}'):
				a-=1
			elif a==1:
				if line.startswith('"Admin"'):
					b=1
				elif line.startswith('"Immunity"'):
					b=2
			elif a==2:
				if line.startswith('"'):
					n=1
					while line[n] != '"':
						group_name += line[n]
						n+=1
					n+=1
					while line[n] != '"':
						n+=1
					n+=1
					e=0
					while line[n] != '"':
						if line[n] not in [' ', '	']:
							flag+=line[n]
						else:
							group_flags.append(flag)
							flag = ""
						n+=1
					while len(group_flags)>0:
						for client in admin:
							for gr in admin[client]['admin_groups']:
								if gr == group_name:
									if group_flags[0] not in admin[client]['admin_flags']:
										admin[client]['admin_flags'].append(group_flags[0])
							for gr in admin[client]['immune_groups']:
								if gr == group_name:
									if group_flags[0] not in admin[client]['immune_flags']:
										admin[client]['immune_flags'].append(group_flags[0])
						group_flags.remove(group_flags[0])
					group_name = ""
	filefixed.close()

def isAdmin(steamID):
	if steamID in admin:
		return 1
	return 0
def hasFlag(steamID, flag):
	if steamID in admin:
		if flag in admin[steamID]['admin_flags']:
			return 1
		elif flag in admin[steamID]['immune_flags']:
			return 2
		return 0
	else:
		raise AdminError("There is no such admin %s" %(steamID))
def hasGroup(steamID, group):
	if steamID in admin:
		if group in admin[steamID]['admin_groups']:
			return 1
		elif group in admin[steamID]['immune_groups']:
			return 2
		return 0
	else:
		raise AdminError("There is no such admin %s" %(steamID))
def AdminName(steamID):
	if steamID in admin:
		return (admin[steamID]['name'])
	else:
		raise AdminError("There is no such admin %s" %(steamID))

def AdminFlags(steamID):
	if steamID in admin:
		return (admin[steamID]['admin_flags'])
	else:
		raise AdminError("There is no such admin %s" %(steamID))

def ImmuneFlags(steamID):
	if steamID in admin:
		return (admin[steamID]['immune_flags'])
	else:
		raise AdminError("There is no such admin %s" %(steamID))
def AdminImmuneGroups(steamID):
	if steamID in admin:
		return (admin[steamID]['admin_groups'])
	else:
		raise AdminError("There is no such admin %s" %(steamID))
def AdminAdminGroups(steamID):
	if steamID in admin:
		return (admin[steamID]['immune_groups'])
	else:
		raise AdminError("There is no such admin %s" %(steamID))

